#!/usr/bin/perl

######################################################################
#
# 2SHOT-CHAT <FreeSoft>
#
; $version = '5.0.1';
#
# (c)1997-2011 by CGI-RESCUE(R) < http://www.rescue.ne.jp/ >
#
######################################################################

# [History] ----------------------------------------------------------
# v1.0 01/SEP/97 リリース
# v1.4 06/OCT/98 状態表示にチャットネームをいれた
# v2.0 19/OCT/98 退室処理の追加、ＣＧＩとＳＳＩの分離、マルチ処理
# v2.1 19/OCT/98 退室処理のログ記録にミスあり
# v2.2 22/MAR/99 チャット入力域のフォーカス
# ---- (データ仕様変更)
# v3.0 05/JUL/99 リモートホスト名の表示機能
# v3.1 14/JUL/99 先に入った人が後から入った人を強制退室させる機能
# v3.2 14/JUL/99 同機能のバグ修正
# v3.3 15/JUL/99 ホスト表示関連のバグ修正
# ---- (データ仕様変更)
# v4.0 27/JUL/99 仕様メジャーチェンジ(フレーム化など)
# v4.1 13/FEB/01 退出させた相手の発言が記録されてしまうバグの修正 (sub-Chatの更新)
# v4.2 21/NOV/01 部外者によるいたずら閉鎖防止処理の追加
# ---- (データ仕様変更)
# v5.0 24/FEB/11 部外者によるいたずら閉鎖防止処理のバグの修正 他 → v5.0.1 バグ修正

# [設置構成] ---------------------------------------------------------
#
#    < >内はパーミッション値(表記の値は参考値)
#
# /2shot/ (ＣＧＩが実行できる任意のディレクトリ)
#    |
#    |-- 2shot.cgi <755>
#    |-- jcode.pl <644>
#    |
#    |--/x/ (データ格納フォルダ) <755>
#        |
#        |-- 01.ent.cgi <666> ... (v5.0～拡張子.cgiをつけました)
#        |-- 01.mes.cgi <666>
#        |-- 01.log.cgi <666>
#
#        |-- 02.ent.cgi <666>
#        |-- 02.mes.cgi <666>
#        |-- 02.log.cgi <666>
#
#        |-- 03.ent.cgi <666>
#        |-- 03.mes.cgi <666>
#        |-- 03.log.cgi <666>
#
#        |   以下略
#        |
#        |-- 部屋ID.ent.cgi (※)
#        |-- 部屋ID.mes.cgi
#        |-- 部屋ID.log.cgi
#        |-- >>用意する部屋分だけ３ファイル１セットとして用意する

#■初期設定

#○このファイルのＵＲＬ
$URL = '/dating/2shot.cgi';

#○日本語処理ライブラリ
## require './jcode.pl';

#○時刻設定
$ENV{'TZ'} = "UTC";

#○データ格納フォルダの場所(Path)
$base_dir = './x/';

#○名称
$title = 'Dating@Heyuri♡♡♡';

#○<BODY>設定
$body = '<body>';

#○反転色設定
$rev_color = '#ffffff';
$rev_back  = '#ff99cc';

#○チャット表示行
$max = '30';

#○ホスト名の告示(2:ソース上にする 1:画面上にする 0:しない)
$view_host = 0;

#○１部屋で会話ログ(.log)で利用できる最大ファイルサイズ
$fuse = 10000;

#○タグを許可 1:する 0:しない(推奨)
$allow_html = 0;

#○空室一覧表の自動更新時間の設定(秒) ... 60秒以上有効
$reload = 60;

#○種別設定
$sex1 = 'Male';
$sex2 = 'Female';
$sex0 = '?????'; #選択しない場合

#○種別の色
$color1 = '#5555ff'; # $sex1の色
$color2 = '#ff0000'; # $sex2の色
$color0 = '#555555'; # $sex0の色

#○種別名
$sex_name = 'Sex';

#○状態表示の色
$color3 = '#8888ff'; # 空室
$color4 = '#cc6633'; # 待機中
$color5 = '#ff0000'; # 満室

#○自分の発言の色(薄めにする？)
$color6 = '#888888';

#○無発言監視タイマ(秒)
## $limit = 600;
$limit = 3600; ## mod

#○画面に挿入するリンクＵＲＬ(URL)と名称
$modoru = 'https://cgi.heyuri.net/';
$modoru_name = 'Home';

#○部屋設定 ... '部屋ID','部屋名',
#
# 注意：各部屋名の最後の文字が、以下の全角文字で終わる場合には、部屋名の最後に半角 \ を挿入してください。
#       ソ噂浬欺圭構蚕十申曾箪貼能表暴予禄兔喀媾彌拿杤歃濬畚秉綵臀藹觸軆鐔饅鷭
#
#   例：'03','ルームA',
#       '04','官能\',
#       '05','官能の部屋',
#
%Room = (

'01','Random room 1',
'02','Random room 2',
'03','Random room 3',
'04','Serious (dating) Business room',
'05','Otaku room',
'06','Emo room ;_;',
'07','Yuri room',
'08','Yaoi room',
'09','ZOMG SEX room',
'10','<span lang="ja">ヽ(´ー｀)ノ</span> room',

);

#○チャットデータにWebから見えないように偽装するための拡張子 (※)
$dummy = '.cgi';

$htmlHeader = '<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="stylesheet" href="/css/global.css">
<link rel="shortcut icon" href="/favicon.ico">
<link rel="stylesheet" href="style.css">';

# --------------------------------------------------------------------

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$date_now = sprintf("%02d:%02d",$hour,$min);
$time_now = time;

if ($ENV{'REQUEST_METHOD'} eq "POST") { read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'}); }
else { $buffer = $ENV{'QUERY_STRING'}; }

@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {

	($name,$value) = split(/=/,$pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
##	&jcode::convert(*value,'sjis');

	if (!$allow_html || $name ne 'Value') {

		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;
	}

	$value =~ s/\t//g;
	$value =~ s/\r\n/\r/g;
	$value =~ s/\n/\r/g;

	if ($name eq 'Clear') { $Clr = 1; next; }
	if ($name eq 'Make') { $Make = 1; next; }

	$in{$name} = $value;
}

if ($in{'img'} eq 'copyright') { &copyright; }
if ($buffer eq '' || $buffer =~ /^\d+$/) { &First; exit; }
if ($in{'action'} ne 'entry') { print "Content-type: text/html\n\n"; }

if ($in{'action'} eq 'Form') { &Form; exit; }
elsif ($in{'action'} eq 'List') { &List; exit; }

if ($in{'room'} eq '') { &error('Error','Please select a room.'); }

$chat_file = $base_dir . "$in{'room'}\.log$dummy";
$entry_file = $base_dir . "$in{'room'}\.ent$dummy";
$mes_file = $base_dir . "$in{'room'}\.mes$dummy";

if (!-e $chat_file) { &error('Error','The log file (log) could not be found.'); }
if (!-e $entry_file) { &error('Error','The control file (ent) could not be found.'); }
if (!-e $mes_file) { &error('Error','The history file (mes) could not be found.'); }

if ($Clr) { &Clear; } # 画面クリア

if ($in{'action'} eq 'entry') { &entry; &InForm; }
elsif ($in{'action'} eq 'ChatForm') { &ChatForm; }
elsif ($in{'action'} eq 'close') { &close(); }
elsif ($in{'action'} eq 'bye' || $in{'action'} eq 'bye2') { &bye; }
elsif ($in{'action'} eq 'Chat') { &Chat; }
else { &error('Abnormality',''); }

exit;

sub ChatForm {

	($Etime) = &GetData($entry_file);
	if ($Etime < 0) { &close(1); }
	if ($Etime > 0 && $limit <= $time_now - $Etime) { &close(2); }

	if (open(IN,$mes_file)) {

		@messages = <IN>; close(IN);
		($uname,$SEX,$message,$host,$agent) = split(/\t/,$messages[$in{'num'}],5);
		if ($SEX eq 'M') { $SEX = "(<font color=$color1>$sex1</font>)"; }
		elsif ($SEX eq 'F') { $SEX = "(<font color=$color2>$sex2</font>)"; }
		else { $SEX = "(<font color=$color0>$sex0</font>)"; }
	}

	$focus = 'onLoad="document.InputForm.Value.focus();"';
	if ($body =~ /<body([^<>]*)>/i) { $body = "<body$1 $focus>"; }

	print <<"EOF";
	<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
	<HTML><HEAD>
	$htmlHeader
	<TITLE>$title - $Room{$in{'room'}}</TITLE>
	<SCRIPT language="JavaScript">
	<!--
	function PageBack(){ history.back(); }
	function send()
	{
		document.InputForm.Value.select();
		document.InputForm.Value.focus();
	}
	function sendTimer() { setTimeout("send()",500); }
	function message1()
	{
		f = confirm("The room will be closed. Are you sure?");
		return f
	}
	function message2()
	{
		f = confirm("Your companion will be kicked. Are you sure?");
		document.InputForm.auto[0].click();
		return f
	}
	function message3()
	{
		f = confirm("Only you will leave the room. Are you sure?");
		return f
	}
	function Reload()
	{
		document.InputForm.Value.value = '';
		document.InputForm.submit();
	}
	//-->
	</SCRIPT>
	</HEAD>
	$body

	<table border=5 cellpadding=2 cellspacing=2>
	<tr><td align=center><strong>《$Room{$in{'room'}}》　</strong>$uname $SEX</td>
	<form method=POST action="$URL" target="Down" onSubmit="sendTimer()">
	<input type=hidden name="action" value="Chat">
	<input type=hidden name="room" value="$in{'room'}">
	<input type=hidden name="pwd" value="$in{'pwd'}">
	<input type=hidden name="num" value="$in{'num'}">
	<td align=center><input type=submit value="Manually update at any time" onClick="Reload()"></td></form>
EOF
	if ($in{'num'} == 0) {

		print <<"EOF";
		<form method=POST action="$URL" target="Down">
		<input type=hidden name="action" value="close">
		<input type=hidden name="room" value="$in{'room'}">
		<input type=hidden name="pwd" value="$in{'pwd'}">
		<input type=hidden name="num" value="$in{'num'}">
		<td align=center><input type=submit value="Close" onClick="message1(); return f"></td></form>
		<form method=POST action="$URL" target="Down">
		<input type=hidden name="action" value="bye2">
		<input type=hidden name="room" value="$in{'room'}">
		<input type=hidden name="pwd" value="$in{'pwd'}">
		<input type=hidden name="num" value="$in{'num'}">
		<td align=center><input type=submit value="Kick your companion" onClick="message2(); return f"></td></form>
EOF
	}
	else {
		print <<"EOF";
		<form method=POST action="$URL" target="Down">
		<input type=hidden name="action" value="bye">
		<input type=hidden name="room" value="$in{'room'}">
		<input type=hidden name="pwd" value="$in{'pwd'}">
		<input type=hidden name="num" value="$in{'num'}">
		<td align=center colspan=2><input type=submit value="Leave room" onClick="message3(); return f"></td></form>
EOF
	}

	print <<"EOF";
	</tr>
	<tr>
	<form method=POST action="$URL" target="Down" name="InputForm" onSubmit="sendTimer()">
	<input type=hidden name="action" value="Chat">
	<input type=hidden name="room" value="$in{'room'}">
	<input type=hidden name="pwd" value="$in{'pwd'}">
	<input type=hidden name="num" value="$in{'num'}">
	<td align=center><input type=text name="Value" size=60>
	<input type=submit value="Speak">
	</td>
	<td align=center colspan=3>&nbsp;<b>Auto-update</b>
	<input type=radio name="auto" id="disableUpdate" value=0 checked onClick="Reload()"><label for="disableUpdate">Disable</label>
	<input type=radio name="auto" id="autoUpdate1" value=20 onClick="Reload()"><label for="autoUpdate1">Auto (20sec)</label>
	<input type=radio name="auto" id="autoUpdate2" value=30 onClick="Reload()"><label for="autoUpdate2">Auto (30sec)</label>&nbsp;
	</td>
	</tr>
	</table>
	<p>
	<small>
	*<strong style="color:#dd0000">The chat does not update automatically by default.</strong>
	*Click the <strong>Speak</strong> or <strong>Manually update at any time</strong> buttons to manually refresh the chat, or select one of the <strong>Auto-update</strong> options.<br>
	*Do not use the refresh button on your browser.<br>
	*Due to the time difference, two people intending to operate a room may end up in the same room.
	</small>
	</form>
	</table>
	</body>
	</html>
EOF

}

sub Chat {

	($Etime) = &GetData($entry_file);
	if ($Etime < 0) { &close(1); }

	if (open(IN,$mes_file)) {

		@messages = <IN>; close(IN);
		($uname,$SEX,$message,$host,$agent) = split(/\t/,$messages[$in{'num'}],5);
	}

	$keika = $time_now - $Etime;
	if ($Etime > 0 && $limit <= $keika) { &close(2); }

	if (-s $chat_file > $fuse) { &close(9); }

	if ($Pwd[$in{'num'}] =~ /^\$1\$/) { $salt = 3; } else { $salt = 0; }
	if ($in{'pwd'} eq '') { &close(3); &error('Closed 1','You could not be authenticated as the current user.','Alternatively, the room was closed due to the data exceeding the file size limit.'); }
	if (crypt($in{'pwd'},$Pwd[$in{'num'}]) ne $Pwd[$in{'num'}] || $Pwd[$in{'num'}] eq '') { &error('Closed',"This chat has ended."); }

	if ($in{'Value'} ne '') { &write; }

	if ($in{'auto'} > 0) {

		$RELinfo = "[$in{'auto'} second auto-update]";
		$META = "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$in{'auto'};URL=$URL?action=Chat&room=$in{'room'}&pwd=$in{'pwd'}&num=$in{'num'}&auto=$in{'auto'}\">";
	}
	else { $RELinfo = "[Manual update]"; }

	if (!open(IN,$chat_file)) { &error('System error','Chat file could not be opened.'); }
	@DATA = <IN>;
	close(IN);

	@DATA = reverse(@DATA);

	print <<"EOF";
	<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
	<HTML><HEAD>
	$htmlHeader
	<TITLE>$title - $Room{$in{'room'}}</TITLE>
	$META
	<SCRIPT language="JavaScript">
	<!--
	function PageBack(){ history.back(); }
	//-->
	</SCRIPT>
	</HEAD>
	$body
EOF
	foreach $data (@DATA) {

		($date,$chat_name,$chat) = split(/\t/,$data);
		$chat =~ s/\n//g;

		if ($chat_name eq $uname) { print "<font color=$color6>$chat_name &gt; $chat</font> <font size=-1 color=$color6>($date)</font><hr>\n"; }
		else { print "<b>$chat_name</b> &gt; $chat <font size=-1>($date)</font><hr>\n"; }
	}

	print <<"EOF";
	<form method=POST action="$URL" target="_self">
	<input type=hidden name="action" value="Chat">
	<input type=hidden name="room" value="$in{'room'}">
	<input type=hidden name="pwd" value="$in{'pwd'}">
	<input type=hidden name="num" value="$in{'num'}">
	<input type=hidden name="auto" value="$in{'auto'}">
EOF
	if ($in{'num'} eq '0') { print "<input type=submit name=\"Clear\" value=\"Clear screen\">\n"; }

	print <<"EOF";
	$RELinfo
	[$keika seconds elapsed since last message → Room will close after $limit seconds of silence]
	[Displaying $max lines]
	</form>
	<p></body></html>
EOF

exit;

}

sub write {

	$in{'Value'} =~ s/<table([^>]|\n)*>//ig;
	$in{'Value'} =~ s/<meta([^>]|\n)*>//ig;
	$in{'Value'} =~ s/<form([^>]|\n)*>//ig;

	if (open(IN,$mes_file)) {

		@messages = <IN>; close(IN);
		($uname,$SEX,$message,$host,$agent) = split(/\t/,$messages[$in{'num'}],5);
	}

	if ($in{'Value'} ne "") {

		if (!open(DB,"$chat_file")) { &error('Error','Chat file could not be opened.'); }
		@lines = <DB>;
		close(DB);

		$axs = @lines;
		if ($axs >= $max) { shift(@lines); }
		push(@lines,"$date_now\t$uname\t$in{'Value'}\n");

		if (!open(DB,">$chat_file")) { &error('Error','Chat file could not be written to.'); }
		print DB @lines;
		close(DB);
	}

	if (!open(IN,$entry_file)) { &error('Error','The entry management file could not be opened.'); }
	$ktime = <IN>;
	@owner_ent = <IN>;
	close(IN);

	if (!open(OUT,">$entry_file")) { &error('Error','The entry management file could not be written to.'); }
	print OUT "$time_now\n";
	print OUT @owner_ent;
	close(OUT);

	$keika = 0;
}

sub entry {

	($Etime) = &GetData($entry_file);
	if ($Etime > 0 && $limit <= $time_now - $Etime) { &close(5); }

	$ninzu = @Pwd;
	if ($ninzu >= 2) { &First; exit; }
	if ($in{'chat_name'} eq '' || $in{'chat_name'} =~ /[\,\;\:]/) { $err = 1; $in{'chat_name'} = 'Anonymous'; }

	if ($ninzu == 1) {

		if (open(IN,$mes_file)) {

			@messages = <IN>; close(IN);
			$messages[0] =~ s/\n//;
			($uname,$SEX,$message,$host,$agent) = split(/\t/,$messages[0],5);
		}

		if ($in{'chat_name'} eq 'Anonymous') { $err = 1; $in{'chat_name'} = 'Anonymous2'; }
		elsif ($in{'chat_name'} eq $uname) { $err = 1; $in{'chat_name'} = 'Anonymous'; }
	}
	else { &close(9); }

	@char = ('a'..'z','A'..'Z','0'..'9');
	srand(time|$$);
	foreach (0..7) {
		{
			local(@temp);
			push(@temp,splice(@char,rand(@char),1)) while @char;
			@char = @temp;
		}
		$passwd = $char[($_)] . $passwd;
	}

	$crypt_password = &Crypt($passwd);
	if (crypt($passwd,$crypt_password) ne $crypt_password) { &error("Error","Failed to issue authentication code.","Please re-enter the vacant room."); }

	if ($in{'sex'} eq 'M') { $SEX = "(<font color=$color1>$sex1</font>)"; }
	elsif ($in{'sex'} eq 'F') { $SEX = "(<font color=$color2>$sex2</font>)"; }
	else { $SEX = "(<font color=$color0>$sex0</font>)"; }

	$host2 = $ENV{'REMOTE_HOST'};
	$addr2 = $ENV{'REMOTE_ADDR'};
	if ($host2 eq '') { $host2 = $addr2; }
	if ($host2 eq $addr2) { $host2 = gethostbyaddr(pack('C4',split(/\./,$host2)),2) || $addr2; }

	$agent2 = $ENV{'HTTP_USER_AGENT'}; $agent =~ s/</(/g; $agent =~ s/>/)/g;

	if ($host eq $host2 && $agent eq $agent2) { &Reset(); &error("Error","Duplicate entry was detected, so the room has been temporarily vacated.","Please check the vacancy status."); }

	if (!open(OUT,">> $mes_file")) { &error('Error','The waiting message file could not be opened.'); }
	print OUT "$in{'chat_name'}\t$in{'sex'}\t$in{'mes'}\t$host2\t$agent2\n";
	close(OUT);

	if (!open(IN,$entry_file)) { &error('Error','The entry management file could not be opened.'); }
	$ktime = <IN>;
	@owner_ent = <IN>;
	close(IN);

	if (!open(OUT,">> $entry_file")) { &error('Error','The entry management file could not be opened.'); }
	if ($ninzu == 0) { print OUT "$time_now\n"; }
	print OUT "$crypt_password\n";
	close(OUT);

	if (!open(DB,">>$chat_file")) { &error('Error','The chat file could not be written to.'); }

	if ($ninzu != 0 && $Make) { $msg1 = 'wishing to be the controller, but a controller was already present'; $msg2 = '(please consult with the controller)'; }
	elsif ($ninzu == 0) { $msg1 = 'as the controller'; }
	elsif ($ninzu == 1) { $msg2 = 'so this chat room has been locked'; }

	if ($view_host == 1) { $host = "<font size=-2>&lt;$host2&gt;</font>"; }
	elsif ($view_host == 2) { $host = "<!-- $host -->"; }
	else { $host = ""; }

	print DB "$date_now\tNotice\t$in{'chat_name'}-san $SEX $host entered the room $msg1 $msg2\.\n";
	if ($in{'mes'} ne '') { print DB "$date_now\tNotice\t$in{'chat_name'}-san's profile: \"$in{'mes'}\"\n"; }
	if ($err) { print DB "$date_now\tNotice\tYou are anonymous because a chat name was not entered or invalid symbols (\<\>\,\;\:) were detected\.\n"; }
	close(DB);

	$in{'Value'} = ""; &write;
}

sub Crypt {

	my $mypass = $_[0];

	srand();
	my @saltset = ('a'..'z','A'..'Z','0'..'9');
	my $nsalt = $saltset[int(rand(64))] . $saltset[int(rand(64))];

	$mypass = crypt($mypass,$nsalt);
	$mypass;
}

sub bye {

	($Etime) = &GetData($entry_file);
	$ninzu = @Pwd;

	if ($Pwd[$in{'num'}] =~ /^\$1\$/) { $salt = 3; } else { $salt = 0; }
	if ($in{'pwd'} eq '') { &error('Closed','You could not be authenticated as the current user.'); }
	if (crypt($in{'pwd'},$Pwd[$in{'num'}]) ne $Pwd[$in{'num'}] || $Pwd[$in{'num'}] eq '') { &error('Closed',"You have already left this chat room."); }

	if (open(IN,$mes_file)) {

		@messages = <IN>; close(IN);
		($uname,$SEX,$message,$host,$agent) = split(/\t/,$messages[$in{'num'}],5);
	}

	if (!open(OUT,">>$chat_file")) { &error('Error','The chat file could not be written to.'); }
	if ($in{'action'} eq 'bye') { print OUT "$date_now\tNotice\t$uname-san has left the room, so the room will be set to waiting\.\n"; }
	elsif ($in{'action'} eq 'bye2' && $ninzu < 2) { print OUT "$date_now\tNotice\tCurrently, there is no one here to be kicked\.\n"; close(OUT); &Chat; }
	else {
		$Pwd[1] = '';
		print OUT "$date_now\tNotice\tThe other party has left the room, so the room will be set to waiting\.\n";
	}
	close(OUT);

	if (!open(IN,$mes_file)) { &error('Error','Wait message file could not be opened.'); }
	@owner_msg = <IN>;
	close(IN);

	if (!open(OUT,">$mes_file")) { &error('Error','Wait message file could not be written to.'); }
	print OUT $owner_msg[0];
	close(OUT);

	if (!open(IN,$entry_file)) { &error('Error','The entry management file could not be opened.'); }
	@owner_ent = <IN>;
	close(IN);

	if (!open(OUT,">$entry_file")) { &error('Error','The entry management file could not be written to.'); }
	print OUT $owner_ent[0];
	print OUT $owner_ent[1];
	close(OUT);

	if ($in{'action'} eq 'bye') { &error("Left the room","Thank you for using this service."); }
	elsif ($in{'action'} eq 'bye2') { &Chat; }
	else { &error("Abnormal closure","Please re-enter through the front page."); }
}

sub Clear {

	if (!open(OUT,">$chat_file")) { &error('Error',"The chat file could not be written to."); }
	print OUT "$date_now\tNotice\tThe screen was cleared by the controller (the person who entered the room first).\n";
	close(OUT);
}

sub close {

	local($csw) = @_;

	if (!$csw) {

		($Etime) = &GetData($entry_file);
		if ($Etime < 0) { &close(1); }
		if ($Etime > 0 && $limit <= $time_now - $Etime) { &close(2); }
		else {
			if (crypt($in{'pwd'},$Pwd[0]) ne $Pwd[0]) {

				if (!open(OUT,">>$chat_file")) { &error('Error',"The chat file could not be written to."); }
				print OUT "$date_now\tNotice to controller\tAn invalid procedure was detected in the participant\'s operation.\n";
				close(OUT);
				&error('Error','An invalid procedure was detected in the participant\'s operation.');
			}
		}
	}

	$ninzu = $disp = $message = $uname = $SEX = $host = $agent = '';
	@Pwd = ();

	&Reset;

	if ($in{'action'} eq 'close') { &error("Closed","Thank you for using this service."); }
}

sub Reset {

	if (!open(OUT,">$chat_file")) { &error('Error',"The chat file could not be written to."); }
	print OUT '';
	close(OUT);

	if (!open(OUT,">$mes_file")) { &error('Error','Wait message file could not be written to.'); }
	print OUT '';
	close(OUT);

	if (!open(OUT,">$entry_file")) { &error('Error','The entry management file could not be written to.'); }
	print OUT '';
	close(OUT);
}

sub GetData {

	local($entry_file) = @_;
	local($Etime);
	@Pwd = ();

	if (open(IN,$entry_file)) {

		$Etime = <IN>;
		$Etime =~ s/\n//g;;

		$i = 0;
		while (<IN>) {

			s/\n//g;
			$Pwd[$i] = $_;
			$i ++;
		}
		close(IN);
	}
	else { $Etime = -1; }

	if ($Etime eq '') { $Etime = 0; @Pwd = (); }

	$size = -s $entry_file;
	if ($Etime == 0 &&  $size != 0) { &close(6); }

	return $Etime;
}

sub List {

	if ($in{'auto'} eq '') { $in{'auto'} = 0; }
	elsif ($in{'auto'} != 0 && $in{'auto'} < 60) { $in{'auto'} = 60; }

	if ($in{'auto'} != 0) { $META = "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$in{'auto'};URL=$URL?action=List&auto=$in{'auto'}\">"; }

	print <<"EOF";
	<html><head>
	$htmlHeader
	$META
	<title></title></head>
	$body
	<p><br>
	<table align=center width=70%><tr><td>
EOF
	if ($in{'auto'} > 0) { print "[$in{'auto'} second auto-update] [<a href=\"$URL?action=List&auto=0\">Set to manual update</a>]\n"; }
	else { print "[<a href=\"$URL?action=List&auto=0\"><b>Manual update</b></a>] [<a href=\"$URL?action=List&auto=$reload\">Auto-update ($reload seconds)</a>]\n"; }

	print <<"EOF";
	<p>
	<table border=3 cellpadding=2 cellspacing=2 width=100%>
	<tr bgcolor="$rev_back">
	<th><font color="$rev_color">Room name</font></th>
	<th><font color="$rev_color">Status</font></th>
	<th><font color="$rev_color">$sex_name</font></th>
	<th><font color="$rev_color">Chat name</font></th>
	<th><font color="$rev_color">Profile</font></th>
	</tr>
EOF
	foreach $room (sort { $a <=> $b } keys %Room) {

		$ninzu = $disp = $message = $uname = $SEX = $host = $agent = '';
		@Pwd = ();

		$chat_file = $base_dir . "$room\.log$dummy";
		$entry_file = $base_dir . "$room\.ent$dummy";
		$mes_file = $base_dir . "$room\.mes$dummy";

		if (!-e "$base_dir$room\.ent$dummy") { print "<tr><th>$Room{$room}</th><td colspan=4 align=center>&nbsp;<small>Data file could not be found ($room)</small>&nbsp;</td>\n"; next; }
		else {
			($Etime) = &GetData("$base_dir$room\.ent$dummy");

			if ($Etime == 0) { $disp = "<font color=$color3>Vacant</font>"; $message = $uname = $SEX = $host = $agent = ''; }
			elsif ($Etime < 0) { print "<tr><th>$Room{$room}</th><td colspan=4 align=center>Abnormality(2)</td>\n"; next; }
			elsif ($limit <= $time_now - $Etime) { &close(7); }

			if (open(IN,"$base_dir$room\.mes$dummy")) { $message = <IN>; close(IN); }
			else { print "<tr><th>$Room{$room}</th><td colspan=4 align=center>Abnormality(3)</td>\n"; next; }

			$message =~ s/\n//;
			($uname,$SEX,$message,$host,$agent) = split(/\t/,$message,5);

			if ($SEX eq 'M') { $SEX = "<font color=$color1>$sex1</font>"; }
			elsif ($SEX eq 'F') { $SEX = "<font color=$color2>$sex2</font>"; }
			else { $SEX = "<font color=$color0>$sex0</font>"; }

			$ninzu = @Pwd;
			if ($ninzu == 1) {

				if ($view_host == 1) { $host = "<br><font size=-2>&lt;$host&gt;</font>"; }
				elsif ($view_host == 2) { $host = "<!-- $host -->"; }
				else { $host = ""; }

				$disp = "<font color=$color4><b>Waiting</b></font>";
			}
			elsif ($ninzu == 2) { $disp = "<font color=$color5>Full</font>"; $message = $uname = $host = $SEX = ''; }
			else { $disp = "<font color=$color3>Vacant</font>"; $message = $uname = $SEX = $host = $agent = ''; }

			print <<"EOF";
			<tr>
			<th nowrap>$Room{$room}</th>
			<td nowrap align=center>&nbsp;$disp&nbsp;</td>
			<td nowrap align=center>&nbsp;$SEX&nbsp;</td>
			<td nowrap>&nbsp;$uname&nbsp;</td>
			<td>&nbsp;$message&nbsp;$host</td>
			</tr>
EOF
		}
	}

	# 著作表示の削除禁止
	print <<"EOF";
	</tr></table>
	<p>[<a href="$modoru" target="_top">$modoru_name</a>]</p>
	</td></tr></table>
	<div align=right><a href="http://www.rescue.ne.jp/" target="_top"><img src="$URL\?img=copyright" border=0 title="2SHOT-CHAT v$version developer/author" width=43 height=35></a></div>
	<div style="font-size:0.75em;font-weight:bold;text-align:right">Translated and modified by <a href="https://www.heyuri.net/">Heyuri</a></div>
	</body></html>
EOF
	exit;
}

sub First {

	print "Content-type: text/html\n\n";

	print <<"EOF";
	<html><head>
	$htmlHeader
	<title>$title</title></head>
	<frameset rows="30%,70%" border=5 bordercolor=#555555>
	<frame src="$URL?action=Form" name="Up">
	<frame src="$URL?action=List" name="Down">
	<noframes>
	$body
	<center>
	<h2>This is a frames-only chat<br>
	Please use a browser that supports frames</h2>
	[<a href="$modoru">$modoru_name</a>]
	</center>
	</body>
	</noframes>
	</frameset>
	</html>
EOF
	exit;
}

sub InForm {

	($secg,$ming,$hourg,$mdayg,$mong,$yearg,$wdayg,$ydayg,$isdstg) = gmtime(time + 30*24*60*60); # 期限を30日後に設定(GMT)
	$y0="Sunday"; $y1="Monday"; $y2="Tuesday"; $y3="Wednesday"; $y4="Thursday"; $y5="Friday"; $y6="Saturday";
	$m0="Jan"; $m1="Feb"; $m2="Mar"; $m3="Apr"; $m4="May"; $m5="Jun"; $m6="Jul"; $m7="Aug"; $m8="Sep"; $m9="Oct"; $m10="Nov"; $m11="Dec";
	@youbi = ($y0,$y1,$y2,$y3,$y4,$y5,$y6);
	@monthg = ($m0,$m1,$m2,$m3,$m4,$m5,$m6,$m7,$m8,$m9,$m10,$m11);
	$date_gmt = sprintf("%s\, %02d\-%s\-%04d %02d:%02d:%02d GMT",$youbi[$wdayg],$mdayg,$monthg[$mong],$yearg +1900,$hourg,$ming,$secg);

	if ($in{'cookie'}) { $cook="chat_name\:$in{'chat_name'}\,sex\:$in{'sex'}\,mes\:$in{'mes'}"; }
	else { $cook=""; $date_gmt = "Sun, 01-Jan-1995 01:00:00 GMT"; }

	print "Set-Cookie: $ENV{'SCRIPT_NAME'}=$cook; expires=$date_gmt\n";
	print "Content-type: text/html\n\n";

	print <<"EOF";
	<html><head>
	$htmlHeader
	<title>$title - $Room{$in{'room'}}</title></head>
	<frameset rows="20%,80%" border=5 bordercolor=#555555>
	<frame src="$URL?action=ChatForm&room=$in{'room'}&pwd=$passwd&num=$ninzu" name="Up">
	<frame src="$URL?action=Chat&room=$in{'room'}&pwd=$passwd&num=$ninzu" name="Down">
	<noframes>
	$body
	<center>
	<h2>This is a frames-only chat<br>
	Please use a browser that supports frames</h2>
	[<a href="$modoru">$modoru_name</a>]
	</center>
	</body>
	</noframes>
	</frameset>
	</html>
EOF
	exit;
}

sub Form {

	$cookies = $ENV{'HTTP_COOKIE'};

	@pairs = split(/;/,$cookies);
	foreach $pair (@pairs) {

		($key,$val) = split(/=/,$pair,2);
		$key =~ s/ //g;

		if ($key eq $ENV{'SCRIPT_NAME'}) {

			@pairs = split(/,/,$val);
			foreach $pair (@pairs) {

				($key,$val) = split(/:/,$pair,2);
				$COOKIE{$key} = $val;
			}
			last;
		}
	}

	# カーソルフォーカス位置
	if ($COOKIE{'chat_name'} eq '') { $focus = 'onLoad="document.InputForm.chat_name.focus();"'; }
	else { $focus = 'onLoad="document.InputForm.mes.focus();"'; }

	if ($body =~ /<body([^<>]*)>/i) { $body = "<body$1 $focus>"; }

	if ($COOKIE{'sex'} eq 'M') { $check1 = " checked"; }
	elsif ($COOKIE{'sex'} eq 'F') { $check2 = " checked"; }
	else { $check0 = " checked"; }

	print <<"EOF";
	<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
	<HTML><HEAD>
	$htmlHeader
	<TITLE>$title</TITLE>
	<SCRIPT language="JavaScript">
	<!--
	function PageBack(){ history.back(); }
	//-->
	</SCRIPT>
	</HEAD>
	$body
	<table align=center width=70%><tr><td>
	<h1>$title</h1>
	<form method=POST action="$URL" target="_parent" name="InputForm">
	<input type=hidden name="action" value="entry">
	<label for="chatName">Chat name</label> <input type=text name="chat_name" id="chatName" value="$COOKIE{'chat_name'}" size=30 maxlength=30>
	<br>
	$sex_name
	<input type=radio name="sex" id="maleRadio" value="M"$check1><label for="maleRadio" style="color:$color1">$sex1</label>
	<input type=radio name="sex" id="femaleRadio" value="F"$check2><label for="femaleRadio" style="color:$color2">$sex2</label>
	<input type=radio name="sex" id="unknownRadio" value="-"$check0><label for="unknownRadio" style="color:$color0">$sex0</label>
	<br>
	<select name="room" size=1>
	<option value="" selected>▼Please select a room</option>
EOF
	foreach $room (sort { $a <=> $b } keys %Room) { print "<option value=\"$room\">$Room{$room}</option>\n"; }

	print <<"EOF";
	</select>
	<input type=submit value="Enter"> <input type=submit name="Make" value="Open">
	<font size=-1><input type=checkbox name="cookie" id="cookieSave" value="1" checked><label for="cookieSave">Remember me</label></font><br>
	<label for="profileMessage">Profile</label> <input type=text name="mes" id="profileMessage" size=50 maxlength=60 value="$COOKIE{'mes'}">
	</form>
	<p style="font-size:0.8125em">Love is in teh air～♪</p>
	</td></tr></table>
	</body></html>
EOF
	exit;
}

sub error {

	local (@msg) = @_;
	local ($i);

	if ($in{'action'} eq 'entry') { print "Content-type: text/html\n\n"; }

	print <<"EOF";
	<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
	<HTML><HEAD>
	$htmlHeader
	<TITLE>$title</TITLE>
	<SCRIPT language="JavaScript">
	<!--
	function PageBack(){ history.back(); }
	//-->
	</SCRIPT>
	</HEAD>
	$body
	<h1>$_[0]</h1>
EOF

	print "<ul>\n";
	foreach $i (1 .. $#msg) { print "<li>$msg[$i]\n"; }

	print <<"EOF";
	<li>[<a href="$URL?$time_now" target="_parent"><b>See available rooms</b></a>]
	<li>[<a href="$modoru" target="_parent">$modoru_name</a>]
	<li>[<a HREF="JavaScript:history.back()">Previous page</a>]
	</ul>
	</body></html>
EOF
	exit;
}

sub copyright {

	@array = (
	"47","49","46","38","39","61","2b","00","23","00","b3","02","00","00","00","00","84","84","84","ff",
	"ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff",
	"ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff",
	"ff","21","f9","04","01","00","00","02","00","2c","00","00","00","00","2b","00","23","00","40","04",
	"c3","50","c8","49","ab","bd","38","6b","00","42","98","9f","06","7a","a4","67","01","15","d7","7d",
	"6a","cb","76","13","f7","9a","e2","26","4b","65","59","ef","b5","1c","f2","98","9b","04","05","14",
	"a9","68","2a","41","a7","a5","4c","0e","8f","21","61","ac","45","44","39","99","cc","27","a7","d8",
	"8b","ae","9e","3f","ee","25","09","13","17","a5","e6","74","76","57","85","11","95","d3","19","0b",
	"4c","97","de","d0","31","dd","f7","5e","e6","23","df","69","27","61","81","3c","2b","32","6d","73",
	"84","14","57","8c","83","8a","8f","66","24","02","8e","90","29","88","95","19","78","98","41","65",
	"9b","46","2b","01","80","36","54","9d","38","34","a6","1f","a9","92","3a","a8","3f","9a","54","33",
	"4d","b1","b2","4f","60","b3","63","6d","a0","b6","a1","6e","9d","7e","41","15","2f","bd","5e","b7",
	"87","4e","8b","2e","4d","93","5b","b2","72","cd","cc","9e","94","9e","c8","a7","d3","29","bc","1e",
	"a4","9a","84","b0","71","d3","5f","cd","b4","d6","9c","d2","d6","6b","1a","11","00","3b");

	print "Content-type: image/gif\n\n";
	foreach (@array) { $data = pack('C*',hex($_)); print $data; }
	exit;
}
